<?php
//TITLE=TCP/IP / UDP/IP connection proxy

$title = 'TCP/IP / UDP/IP connection proxy';
$progname = 'connproxy';

$text = array(
   '1. Purpose' => "

Are you behind a disturbing firewall, that does not
allow you to run any public services for the Internet?
<p>
Do you have access to a non-firewalled computer somewhere?
Can you connect to it with ssh? If you can, <em>connproxy</em> will
solve the rest of your problems.

", '1. Overview' => "

<em>connproxy</em> consists of two programs: <em>connmaster</em>
and <em>connbeacon</em>. Connmaster is run on your computer,
and connbeacon is run on the non-firewalled computer. The programs
will talk to each others, and connbeacon starts receiving connections.
The connection between connbeacon and connmaster will work as
a wormhole which makes the Internet behind your firewall able
to reach your computer.

", '1. Usage' => "

Example of use:<blockquote>
 
  <code>twinpipe \"connmaster -t6667:22\"   \"ssh 10.104.2.2 connbeacon\"</code><br>
  (Tunnels tcp port 6667 of 10.104.2.2 to local 22)
  <p>
  (Note you could also do this with ssh alone without connproxy:<br>
    <code>ssh -R6667:localhost:22 10.104.2.2</code>)<p>
  
  But -- you can not forward UDP ports with ssh:<br>
  
  <code>twinpipe \"connmaster -u4665\" \"ssh 10.104.2.2 connbeacon\"</code>
</blockquote>
<p>
You will also need the <a href=\"http://bisqwit.stc.cx/src/index/twinpipe\">twinpipe</a>
program, which connects the stdins and stdouts of the master and beacon program together.<br>
A working version of twinpipe is included in the package, so you don't need a separate download.
<p>
Note that you do not actually need ssh. <em>Any</em> way you can make the beacon
and master communicate with each other (one's stdin becomes other's stdout)
will work.
<p>
You can masquerade multiple tcp and udp ports with just the one wormhole.
<p>
tcp-to-udp or udp-to-tcp conversions are theoretically possible,
but not implemented due to unapplicability.

", '1. Copying' => "

connproxy has been written by Joel Yliluoma, a.k.a.
<a href=\"http://bisqwit.stc.cx/\">Bisqwit</a>,<br>
and is distributed under the terms of the
<a href=\"http://www.gnu.org/licenses/licenses.html#GPL\">General Public License</a> (GPL).

", '1. To do' => "

<ul>
 <li>Anything-over-http support (http is usually the least firewalled service)</li>
 <li>Implicit connection</li>
 <li>Manual pages</li>
 <li>Invent a way to not lose the information about connectee (kernel-level stuff, sorry)</li>
 <li>Gatewaying of outgoing connections also (eeh, this is ppp/vpn stuff already)</li>
 <li>Intense testing of udp forwarding. It has actually not been tested yet.</li>
</ul>

", '1. Requirements' => "

connproxy has been written in C++.<br>
GNU make is required.<br>
The <code>poll</code> system call is also required.
This may or may not cause problems on *BSD systems.<br>
connproxy compiles without warnings at least on g++ versions 2.95.2, 3.0.1 and 3.0.3 in Linux.<br>
The protocol and structure of connproxy are system independent.
The master and beacon ends of the wormhole don't need to have
the same operating system or hardware architechture.

");
include '/WWW/progdesc.php';
