#include "connection.hh"
#include "datapacket.hh"
#include "buffer.hh"

/* Server socket record */
/* This record contains enough information for
 * the server to know what to do with the fd.
 */
struct Socket
{
    enum SockType
    {
        SockTypeListening,
        SockTypeConnected,
        SockTypeConnecting
    };

    int                fd;
    enum SockType      Type;
    
    Connection         Peer;
    
    Buffer             SendQueue;
    
    void BecomeListenerTCP(int port);
    void BecomeListenerUDP(int port);
    
    void BecomeConnecterTCP(int port, const char *ip);
    void BecomeLocalConnecterTCP(int port);
    void BecomeLocalSenderUDP(int port);
    
    DataPacket AcceptTCP(const Socket &parent);
    DataPacket ReceiveUDP();
    DataPacket ReceiveTCP();
    DataPacket Die();
    
    int CheckError();
    
    void SendTCP(const vector<Datatype> &data);
    void SendUDP(const vector<Datatype> &data);
    
    void SendTCP();
    void SendUDP();
};
